﻿using System.Collections.ObjectModel;
using DragDropFrameworkPOC.BaseClasses;

namespace DragDropFrameworkPOC
{
  public class ZooViewModel:ViewModelBase,IDropTarget
  {

    #region Public Properties

    /// <summary>
    /// Gets or sets the Zoo where only animals stay.
    /// </summary>
    public ObservableCollection<Animal> AnimalCollection { get; set; }

    #endregion

    #region CTOR

    public ZooViewModel()
    {
       AnimalCollection = new ObservableCollection<Animal>();
    }

    #endregion

    #region Base Class overrides

    protected override string VerifyPropertyValue(string propertyName)
    {
      return null;
    }

    #endregion

    #region

    public bool IsDropTarget
    {
      get { return true; }
    }

    public void OnDropped(object arg)
    {
      if (arg is Animal)
      {
        AnimalCollection.Add(arg as Animal);
      }
    }

    public ObservableCollection<string> DropChannels
    {
      get { return GetDropChannels(); }
    }

    private ObservableCollection<string> GetDropChannels()
    {
      return new ObservableCollection<string>()
        {
          Channels.AnimalChannel
        };
    }

    #endregion
  }
}